var key=new RegExp("Giant zombie");
function addGiantSpawnEgg(id,size){
	if(!Item.isValidItem(id)){
		ModPE.setItem(id,"spawn_egg",12,(size*2)+"M Giant zombie",64);
		Item.setCategory(id,ItemCategory.TOOL);
		Player.addItemCreativeInv(id,1,0);
	}
}
function createGiantRenderer(size){
	var renderer=Renderer.createHumanoidRenderer();
	var model=renderer.getModel();
	var head=model.getPart("head").clear();
	var body=model.getPart("body").clear();
	var rArm=model.getPart("rightArm").clear();
	var lArm=model.getPart("leftArm").clear();
	var rLeg=model.getPart("rightLeg").clear();
	var lLeg=model.getPart("leftLeg").clear();
	body.setTextureSize(64*size,32*size);
	rArm.setTextureSize(64*size,32*size);
	lArm.setTextureSize(64*size,32*size);
	rArm.setRotationPoint(0,12-12*(size-1),0);
	lArm.setRotationPoint(0,12-12*(size-1),0);
	body.setTextureOffset(0,0,true);
	body.addBox(-4*size,-8*size-24*(size-1),-4*size,8*size,8*size,8*size);
	body.setTextureOffset(16*size,16*size,true);
	body.addBox(-4*size,-24*(size-1),-2*size,8*size,12*size,4*size);
	body.setTextureOffset(32*size,0,true);
	body.addBox(-8*size,-24*(size-1),-10*size,4*size,4*size,12*size);
	body.setTextureOffset(32*size,0,true);
	body.addBox(4*size,-24*(size-1),-10*size,4*size,4*size,12*size);
	rArm.setTextureOffset(0,16*size,true);
	rArm.addBox(1-4*(size-1),0,-2*size,4*size,12*size,4*size);
	lArm.setTextureOffset(0,16*size,true);
	lArm.addBox(-5,0,-2*size,4*size,12*size,4*size);
	return renderer;
}
function spawnGiant(x,y,z,size,name){
	var giant=Level.spawnMob(x,y,z,32);
	Entity.setMobSkin(giant,"mob/giant.png");
	Entity.setRenderType(giant,createGiantRenderer(size).renderType);
	Entity.setCollisionSize(giant,0.6*size,1.8*size);
	Entity.setCarriedItem(giant,0,0,0);
	Entity.setArmor(giant,0,0,0);
	Entity.setArmor(giant,1,0,0);
	Entity.setArmor(giant,2,0,0);
	Entity.setArmor(giant,3,0,0);
	Entity.addEffect(giant,12,9999999*9999999,0,false,false);
	if(name==null)var name="";
	Entity.setNameTag(giant,name+"§大"+size);
}
function loadGiant(entity){
	if(Entity.getEntityTypeId(entity)===32&&Entity.getMobSkin(entity)==="mob/giant.png"){
		var size=Entity.getNameTag(entity).split("§大")[1]*1;
		Entity.setRenderType(entity,createGiantRenderer(size).renderType);
		Entity.setCollisionSize(entity,0.6*size,1.8*size);
		Entity.setCarriedItem(entity,0,0,0);
		Entity.setArmor(entity,0,0,0);
		Entity.setArmor(entity,1,0,0);
		Entity.setArmor(entity,2,0,0);
		Entity.setArmor(entity,3,0,0);
		Entity.addEffect(entity,12,9999999*9999999,0,false,false);
	}
}
function useGiantSpawnEgg(x,y,z,id,side){
	var iName=Item.getName(id);
	if(!(key.test(iName)))return;
	if(Level.getDifficulty()===0)return;
	switch(side){
		case 0:y--;break;
		case 1:y++;break;
		case 2:z--;break;
		case 3:z++;break;
		case 4:x--;break;
		case 5:x++;break;
	}
	var cName=Player.getItemCustomName(Player.getSelectedSlotId());
	var giant=spawnGiant(x+0.5,y,z+0.5,(iName.split("M")[0]/2),cName);
	if(Level.getGameMode()===0){
		var count=Player.getCarriedItemCount()-1;
		if(count===0)itemId=0;
		Entity.setCarriedItem(getPlayerEnt(),id,count,0);
		if(count!==0)Player.setItemCustomName(Player.getSelectedSlotId(),cName);
	}
}
addGiantSpawnEgg(2000,0.25);
addGiantSpawnEgg(2001,0.5);
addGiantSpawnEgg(2002,2);
addGiantSpawnEgg(2003,3);
addGiantSpawnEgg(2004,4);
addGiantSpawnEgg(2005,5);
addGiantSpawnEgg(2006,6);
function entityAddedHook(entity){
	loadGiant(entity);
}
function useItem(x,y,z,item,block,side){
	useGiantSpawnEgg(x,y,z,item,side);
}